/*
 * DRtalk.java
 *
 * Created on 17. august 2009, 13:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package webreader;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import org.json.JSONArray;
import org.json.JSONException;



/**
 *
 * @author Rune
 */
public class DRtalk {

    /** Creates a new instance of DRtalk */
    public DRtalk() {
    }
    
    public void fillScheduleList(LinkedList<tvInfo> tvInfoList, String broadcastDate, String channel_source_url){
        this.parseSchedule(tvInfoList, this.getSchedule(channel_source_url, broadcastDate), broadcastDate, channel_source_url);
    }

    public void parseSchedule(LinkedList<tvInfo> tvInfoList, String scheduleString, String date, String channelID){
        if(scheduleString==null)
            return;

        org.json.JSONArray scheduleData;
        try{
            //Get the result which are the data
            scheduleData =  new org.json.JSONObject(scheduleString).getJSONArray("result");
            org.json.JSONObject schedule = null;
            for (int i=0; i  < scheduleData.length();i++){
                try{
                    schedule = scheduleData.getJSONObject(i);

                    if(!schedule.optString("ppu_title").isEmpty()){
                        tvInfo tvInfoData = new tvInfo();
                        tvInfoData.Program = schedule.getString("ppu_title") ;
                        tvInfoData.ProgramInfo = schedule.optString("ppu_punchline", null);
                        tvInfoData.ProgramInfoExt = schedule.optString("ppu_description", null);
                        //Read program rating
                        tvInfoData.Rating = schedule.optString("pro_targetgroup", null);

                        //Url for specific program or show in general
                        tvInfoData.PromoUrl = schedule.optString("prd_promo", null);
                        if (!schedule.optString("prd_promo").isEmpty())
                            tvInfoData.PromoUrl = "http://www.dr.dk" + schedule.getString("prd_promo");
                        else if (!schedule.optString("ppu_www_url").isEmpty())
                            tvInfoData.PromoUrl = "http://" + schedule.getString("ppu_www_url");

                        //Read pg_start
                        if (!schedule.has("pg_start"))
                            continue;


                        tvInfoData.StartTime = schedule.getString("pg_start").substring(0,4);//Year
                        tvInfoData.StartTime += schedule.getString("pg_start").substring(5, 7);//Month
                        tvInfoData.StartTime += schedule.getString("pg_start").substring(8,10);//Day
                        tvInfoData.StartTime += schedule.getString("pg_start").substring(11,13);//Hour
                        tvInfoData.StartTime += schedule.getString("pg_start").substring(14,16);//Minuttes
                        tvInfoData.StartTime += schedule.getString("pg_start").substring(17,19);//Seconds
                        Long.parseLong(tvInfoData.StartTime);//Test that we have a working number


                        //Read pg_stop
                        if (!schedule.has("pg_stop"))
                            continue;

                        tvInfoData.StopTime = schedule.getString("pg_stop").substring(0,4);//Year
                        tvInfoData.StopTime += schedule.getString("pg_stop").substring(5, 7);//Month
                        tvInfoData.StopTime += schedule.getString("pg_stop").substring(8,10);//Day
                        tvInfoData.StopTime += schedule.getString("pg_stop").substring(11,13);//Hour
                        tvInfoData.StopTime += schedule.getString("pg_stop").substring(14,16);//Minuttes
                        tvInfoData.StopTime += schedule.getString("pg_stop").substring(17,19);//Seconds
                        Long.parseLong(tvInfoData.StopTime);//Test that we have a working number


                        //Read ppu_isrerun
                        tvInfoData.repeat = schedule.optBoolean("ppu_isrerun", false);


                        //Read episode number
                        int episodeIndexStart = tvInfoData.Program.indexOf('(');
                        int episodeIndexEnd = tvInfoData.Program.indexOf(')', episodeIndexStart);
                        String episode = null;
                        String episodeNo = null;
                        String episodeMax = null;
                        if( (episodeIndexStart>0) && (episodeIndexEnd>episodeIndexStart) )
                        {
                            //System.out.println(ppu_title);
                            //System.out.println(EpisodeIndexStart + " " + EpisodeIndexEnd + " : " );
                            episode = tvInfoData.Program.substring(episodeIndexStart+1, episodeIndexEnd);
                            int episodeIndexColon = episode.indexOf(':');//Find out if there are a max series number too.
                            if(episodeIndexColon!=-1){
                                episodeNo = episode.substring(0, episodeIndexColon);
                                episodeMax = episode.substring(episodeIndexColon+1);
                            }
                            else{
                                episodeNo = episode;
                            }

                            try{
                                //Build episode number based on xmltv_ns: http://xml.coverpages.org/XMLTV-DTD-20021210.html
                                tvInfoData.EpisodeNo = Integer.parseInt(episodeNo);//-1; //see if it is a number

                                if(episodeMax!=null)
                                    tvInfoData.EpisodeMax = Integer.parseInt(episodeMax);//-1;//see if it is a number

                                episode = episodeNo;
                                //Remove episode number from title
                                tvInfoData.Program = tvInfoData.Program.substring(0, episodeIndexStart).trim();
                            }catch( NumberFormatException ex){
                                episode = null;
                                //System.out.println("Episode Exception: eNo:" + episodeNo + " mNo:" + episodeMax);
                            }
                        }


                        //if no episode number is present in the title, read the episode tag
                        if(episode==null){
                            if (schedule.has("prd_episode_number")){
                                tvInfoData.EpisodeNo = schedule.getInt("prd_episode_number");
                                if (schedule.has("prd_episode_total_number"))
                                    tvInfoData.EpisodeMax = schedule.getInt("prd_episode_total_number");
                            }
                        }



                        if(tvInfoData.Program!=null){
                            tvInfoData.Program = tvInfoData.Program.replace("\\\"","\"");//Convert escaped quotes to just quotes.
                            tvInfoData.Program = tvInfoData.Program.replace("\\t"," ");//Convert escaped tabs to just a space.
                            tvInfoData.Program = tvInfoData.Program.replace("<", "&lt;").replace(">", "&gt;");
                        }
                        if(tvInfoData.ProgramInfo!=null){
                            tvInfoData.ProgramInfo = tvInfoData.ProgramInfo.replace("\\\"","\"");
                            tvInfoData.ProgramInfo = tvInfoData.ProgramInfo.replace("\\t"," ");
                            tvInfoData.ProgramInfo = tvInfoData.ProgramInfo.replace("<", "&lt;").replace(">", "&gt;");
                        }
                        if(tvInfoData.ProgramInfoExt!=null){
                            tvInfoData.ProgramInfoExt = tvInfoData.ProgramInfoExt.replace("\\\"","\"");
                            tvInfoData.ProgramInfoExt = tvInfoData.ProgramInfoExt.replace("\\t"," ");
                            //ppu_description = ppu_description.replaceAll("\\."," ");//Bad idea, not all are escape codes!
                            tvInfoData.ProgramInfoExt = tvInfoData.ProgramInfoExt.replace("<", "&lt;").replace(">", "&gt;");
                        }

                        //Read video format
                        tvInfoData.Video = schedule.optString("ppu_video", null);
                        //Read audioformat
                        if(schedule.has("ppu_audio"))
                            tvInfoData.Audio = schedule.getString("ppu_audio").toLowerCase();

                        //read production year
                        if (schedule.has("prd_prodyear"))
                            tvInfoData.ProductionYear = schedule.getString("prd_prodyear").substring(6,10);

                        //Read Genre code
                        String prd_genre_code = schedule.optString("prd_genre_code", null);
                        if(prd_genre_code != null){
                            prd_genre_code = prd_genre_code.trim();
                            String genre_code_split[] = prd_genre_code.split(":");
                            if(genre_code_split.length>0){
                                tvInfoData.GenreMain = Integer.parseInt(genre_code_split[0]);
                            }
                            if(genre_code_split.length>1){
                                tvInfoData.GenreSub = Integer.parseInt(genre_code_split[1]);
                            }
                            //System.out.println("MainGenre:" + prd_genre_code_main + " Sub:" + prd_genre_code_sub);
                        }
                        //Read Genre text
                        tvInfoData.Category = schedule.optString("prd_genre_text", null);
                        if(tvInfoData.Category.equals("Ukategoriseret")) {
                            tvInfoData.Category = null;
                        }

                        //Read subtitles
                        if(schedule.has("ppu_subtext_type"))
                        {
                            String ppu_subtext_type = schedule.getString("ppu_subtext_type").trim();
                            if(ppu_subtext_type.equalsIgnoreCase("TTV"))
                                tvInfoData.Subtitles = "teletext";
                            else if(ppu_subtext_type.equalsIgnoreCase("TH"))
                                tvInfoData.Subtitles = "onscreen";

                        }

                        //read credits
                        credits myCredits = null;


                        //put credits into credits object
                        if(schedule.has("ppu_credits")){
                            String ppu_credits = schedule.getString("ppu_credits");
                            ppu_credits = ppu_credits.replace("\\\"","\"");
                            ppu_credits = ppu_credits.replace("\\t"," ");
                            ppu_credits = ppu_credits.replace("<", "&lt;").replace(">", "&gt;");
                            int startIndex = -1;
                            int endIndex = -1;
                            Pattern myPat = Pattern.compile("Medvirkende:|Instruktion:|Instrukt�r:");
                            Matcher myMatch = myPat.matcher(ppu_credits);
                            if (myMatch.find()){
                                myCredits = new credits();

                                startIndex = myMatch.end();
                                String creditsTag = myMatch.group();
                                while(myMatch.find()) {
                                    endIndex = myMatch.start();
                                    DoCredits(creditsTag,ppu_credits.substring(startIndex, endIndex), myCredits);
                                    startIndex =  myMatch.end();
                                    creditsTag = myMatch.group();
                                }
                                endIndex = ppu_credits.length();
                                DoCredits(creditsTag,ppu_credits.substring(startIndex, endIndex), myCredits);
                            }
                            ppu_credits = null;
                        }

                        //Read production country

                        if(schedule.has("prd_prodcountry")){
                            tvInfoData.ProductionCountry = schedule.getString("prd_prodcountry");
                            tvInfoData.ProductionCountry = tvInfoData.ProductionCountry.replace("\\\"","\"");
                            tvInfoData.ProductionCountry = tvInfoData.ProductionCountry.replace("\\t"," ");
                            tvInfoData.ProductionCountry = tvInfoData.ProductionCountry.replace("<", "&lt;").replace(">", "&gt;");

                            if (tvInfoData.ProductionCountry.toLowerCase().contains("placerbar"))
                                tvInfoData.ProductionCountry = null;


                        }

                        if(false){
                            System.out.println(tvInfoData.StartTime);
                            System.out.println(tvInfoData.StopTime);
                            System.out.println(tvInfoData.Program);
                            System.out.println(tvInfoData.ProgramInfo);
                            System.out.println(tvInfoData.ProgramInfoExt);
                            System.out.println("Rerun:" + tvInfoData.repeat);
                            System.out.println("Episode:" + episode + "   - " + episodeNo);
                        }

                        if(Long.parseLong(tvInfoData.StopTime)>=Long.parseLong(tvInfoData.StartTime)){
                            tvInfoData.Channel = channelID;
                            tvInfoData.Credits = myCredits;
                            tvInfoList.add(tvInfoData);
                        }
                        else {
                            System.err.println("Error parsing schedule stop before start\n" +
                                    "Start: " + tvInfoData.StartTime + "\n" +
                                    "Stop:  " + tvInfoData.StopTime + "\n" +
                                    "Program: " + tvInfoData.Program + " chan: " + tvInfoData.Name);
                        }
                    }
                } catch (Exception ex){
                    System.err.println("Error parsing schedule string:" + schedule.toString());
                    System.err.println(ex.getMessage());
                 }
            }

        } catch (Exception ex){
            System.err.println("Error passing schedule string:" + scheduleString); //TODO
            System.err.println(ex.getMessage());
        }
    }
    
    /** Returns a list of broadcast dates that are >= current broadcast date */
    public LinkedList<String> getUsefulBroadcastDates(){
        LinkedList<String> ll = this.getParsedAvailableBroadcastDates();
        String currentBroadcastData = this.getParsedCurrentBroadcastDate();
        while(true){
            if(ll.getFirst().equals(currentBroadcastData))
                break;
            else
                ll.removeFirst();
        }
        return ll;
    }
    private void DoCredits(String creditsTag, String names, credits creditsData){
        names = names.trim().replace(".", "");
        String[] nameList = names.split("og|,");
        if(creditsTag.equalsIgnoreCase("Medvirkende:")){
            for(String name : nameList){
                if(name.contains(":")){
                    int colonIndex = name.indexOf(":");

                    actor actorData = new actor();
                    actorData.role = name.substring(0, colonIndex).trim().replace("\"", "&quot;");
                    actorData.actorName = name.substring(colonIndex+1).trim();
                    creditsData.Actor.add(actorData);
                }
                else
                    creditsData.Actor.add(new actor(name.trim()));
            }
        }
        else if(creditsTag.equalsIgnoreCase("Instruktion:") | creditsTag.equalsIgnoreCase("Instrukt�r:")){
            for(String name : nameList){
               creditsData.Director.add(name.trim());
            }
            
        }
            
            
    }
    
    /** Returns a linked list of available broadcast dates */
    public LinkedList<String> getParsedAvailableBroadcastDates(){
        String availableBroadcastDates = this.getAvailableBroadcastDates();
        
        LinkedList<String> ll = new LinkedList<String>();
        if(availableBroadcastDates.indexOf("\"error\"")!=-1)
            return null;
        
        int resultIndex = availableBroadcastDates.indexOf("\"result\"");
        int dataIndex = availableBroadcastDates.indexOf("[", resultIndex);
        //System.out.println("res:" + resultIndex + " dat:" + dataIndex);
        if((resultIndex==-1) || (dataIndex==-1))
            return null;
        
        int startIndex = 0;// = availableBroadcastDates.indexOf("\"", dataIndex);
        int endIndex = dataIndex;//availableBroadcastDates.length();
                
        while(true)
        {
            startIndex = availableBroadcastDates.indexOf("\"", endIndex+1);
            endIndex = availableBroadcastDates.indexOf("\"", startIndex+1);
            //System.out.println("start:" + startIndex + " end:" + endIndex);
            if((startIndex==-1) || (endIndex==-1))
                break;
            String availableBroadcastDate = new String();
            availableBroadcastDate = availableBroadcastDates.substring(startIndex+1, endIndex);
            //System.out.println(availableBroadcastDate);
            ll.add(availableBroadcastDate);
        }                    
        return ll;
    }
    
    /** <b>Returns a list of channels.</b><br>
     * Type is either tv or radio.
     */
    public String getChannels(String type){
        int retries = 10;
        String str = null;
        do{
            str = this.query("getChannels", "\"type\":" + type);
        }while((retries--!=0) && (str==null)); 
        if(retries==0)
            System.out.println("Timeout reading channels.");
        return str;
    }
    
    public LinkedList<channelData> getParsedChannels(String type){
        String channels = this.getChannels(type);
        String name;
        String source_url;
        LinkedList<channelData> ll = new LinkedList<channelData>();
        
        org.json.JSONArray channelData;
        try {
            //Get the result which are the data
            channelData = new org.json.JSONObject(channels).getJSONArray("result");
       
            org.json.JSONObject schedule = null;
            for (int i=0; i  < channelData.length();i++){
                org.json.JSONObject channel = channelData.getJSONObject(i);

                name = channel.optString("name", null);
                source_url = channel.optString("source_url", null);
                if( (name!=null) && (source_url!=null) ){
                    channelData cd = new channelData();
                    cd.icon = source_url.substring(source_url.lastIndexOf('/')+1);
                    cd.name = name;
                    cd.source = source_url;
                    ll.add(cd);
                    //System.out.println(source_url);
                }
            }
        } catch (JSONException ex) {
            Logger.getLogger(DRtalk.class.getName()).log(Level.SEVERE, null, ex);
        }
        return ll;
    }

    public void printChannels(){
        String channels = this.getChannels("tv");
        if(channels.indexOf("\"error\"")!=-1)
            return;
        
        int resultIndex = channels.indexOf("\"result\"");
        if(resultIndex==-1)
            return;
        
        int startSrcIndex = 0;
        int endSrcIndex = resultIndex;
        int startNameIndex = 0;
        int endNameIndex = resultIndex;
        
        while(true){
            startNameIndex = channels.indexOf("\"name\":", endSrcIndex);
            endNameIndex = channels.indexOf("\"", startNameIndex+8);
            
            startSrcIndex = channels.indexOf("\"source_url\":", endSrcIndex);
            endSrcIndex = channels.indexOf("\"", startSrcIndex+14);
            if((startSrcIndex==-1)||(endSrcIndex==-1))
                break;
            else{
                String source_url = channels.substring(startSrcIndex+14, endSrcIndex);
                String channelName = channels.substring(startNameIndex+8, endNameIndex);
                String gif = source_url.substring(source_url.length()-3);
                System.out.println("<channel id = \"" + source_url + "\">\n" +
                        "  <display-name>"+ channelName + "</display-name>\n" +
                        "  <icon>http://www.dr.dk/tjenester/programoversigt/Images/Logos/" + gif + ".gif</icon>\n" +
                        "</channel>");
            }
        }
        return;
    }
    
    /** Returns a list of programs.*/
    public String getSchedule(String channel_source_url, String broadcastDate){
        int retries = 10;
        String str = null;
        do{
            str = this.query("getSchedule", "\"channel_source_url\" : \"" + channel_source_url + "\", \"broadcastDate\" : \"" + broadcastDate + "\"");
        }while((retries--!=0) && (str==null)); 
        if(retries==0)
            System.out.println("Timeout reading:" + channel_source_url + "  " + broadcastDate);
        return str;
    }
    
    /** Returns a string of available broadcast dates.*/
    public String getAvailableBroadcastDates(){
        int retries = 10;
        String str = null;
        do{
            str = this.query("availableBroadcastDates", "");
        }while((retries--!=0) && (str==null)); 
        if(retries==0)
            System.out.println("Timeout reading broadcast dates.");
        return str;        
    }
    
    /** Returns a string with current broadcast date.*/
    public String getCurrentBroadcastDate(){
        int retries = 10;
        String str = null;
        do{
            str = this.query("currentBroadcastDate", "");
        }while((retries--!=0) && (str==null)); 
        if(retries==0)
            System.out.println("Timeout reading current broadcast date");
        return str;        
    }
    
    /** Return a parsed currentBroadcastDate */
    public String getParsedCurrentBroadcastDate(){
        String currentBroadcastDate = this.getCurrentBroadcastDate();
        if(currentBroadcastDate.indexOf("\"error\"")!=-1)
            return null;
        
        int resultIndex = currentBroadcastDate.indexOf("\"result\"");
        if(resultIndex==-1)
            return null;
        
        int startIndex = currentBroadcastDate.indexOf("\"", resultIndex+8);
        int endIndex = currentBroadcastDate.indexOf("\"", startIndex+1);
        if((startIndex==-1)||(endIndex==-1))
            return null;
        
        String parsedCurrentBroadcastDate = currentBroadcastDate.substring(startIndex+1, endIndex);
        //System.out.println("start:" + startIndex + " end:" + endIndex);
        //System.out.println(parsedCurrentBroadcastDate);
        
        return parsedCurrentBroadcastDate;
    }
    
    /** Function talking to www.dr.dk through JSON-RPC
     *
     */
    public String query(String method, String params){
        boolean debug = false;
        Socket s = null;
        
        try {
            //Create and send html POST 
            String host = "www.dr.dk";
            String file = "/tjenester/Programoversigt/DBService.ashx";
            //String method = "system.version";
            //String params = "/* void */";
            String id = String.valueOf((int)Math.floor(Math.random()*65536));
            String contentString = "{\"id\":" + id + ",\"method\":\"" + method + "\",\"params\":{ " + params + " }}";
            String contentLength = Integer.toString(contentString.length());
            if(debug)
                System.out.println("String length:" + contentLength);

            int port = 80;
            s = new Socket(host, port);
            OutputStream out = s.getOutputStream();
            PrintWriter outw = new PrintWriter(out, false);
            outw.print("POST " + file + " HTTP/1.1\r\n");
            outw.print("host: " + host + "\r\n");
            outw.print("User-Agent: RDJ/EPG-to-XML\r\n");
            outw.print("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n");
            outw.print("Accept-Encoding: gzip,deflate\r\n");
            outw.print("Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n");
            outw.print("Content-Type: text/plain; charset=utf-8\r\n");
            outw.print("X-JSON-RPC: " + method + "\r\n");
            outw.print("Content-Length: " + contentLength + "\r\n");
            outw.print("Keep-Alive: 300\r\n");
            outw.print("Connection: keep-alive\r\n");
            outw.print("Pragma: no-cache\r\n");
            outw.print("Cache-Control: no-cache\r\n");
            outw.print("\r\n");
            outw.print(contentString);//RDJ added method
            outw.flush();
            
            InputStream in = s.getInputStream();
            InputStreamReader inr = new InputStreamReader(in);
            BufferedReader br = new BufferedReader(inr);
            String line;
            int content_length_read = -1;
            boolean httpOKreceived = false;
            char[] inputBuff;// = new char[bufferSize];
            
            //Wait for stream to be ready. With timeout.
            int timeout = 100;
            while(!br.ready()){
                if(timeout--==0){
                    //System.out.println("timeout waiting for data!");
                    return null;
                }
                try {
                    Thread.sleep(100);                    
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }                    
            }
            while ((line = br.readLine()) != null) {
                if(debug)
                    System.out.println(line);
                if(line.indexOf("HTTP/1.1 200 OK")!=-1){
                    httpOKreceived = true;
                    //System.out.println("HTTP OK !!!!!!!!!!!!!!!!!!!!!!!!!!!");
                }
                if(line.indexOf("Content-Length:")!=-1){
                    String content_length_str = line.substring(15);
                    content_length_read = Integer.parseInt(content_length_str.trim());
                    //System.out.println(content_length_read + "   !!!!!!!!!!!!!!!!!!!!!!!!!!!");
                }
                if(line.length()==0){//empty line seperating blocks
                    if(content_length_read>0){//Read the content which doesn't end with a newline
                        if(httpOKreceived){
                            inputBuff = new char[content_length_read];
                        
                            int chars_read = br.read(inputBuff, 0, content_length_read);//Read input stream
                            while(chars_read<content_length_read){//Read the rest of the stream if we didn't get it all
                                if(br.ready())
                                    chars_read += br.read(inputBuff, chars_read, content_length_read-chars_read);//Read input stream
                            }
                            //System.out.println("Characters read: " + chars_read + " Content length: " + content_length_read);
                        
                            //System.out.println(inputBuff);
                            //Convert char array to string and convert to UTF-8 format.
                            String modifiedBuffer = new String(String.valueOf(inputBuff).getBytes(), "UTF-8");

                            //Check that the id in the response matches the one in the request.
                            int idIdx = modifiedBuffer.indexOf("\"id\":");
                            int idIdxEnd = modifiedBuffer.indexOf(",", idIdx);
                            if( (idIdx==-1) || (idIdxEnd==-1)){
                                System.out.println("No id in response! Will retry.");
                                return null;
                            }
                            if(!id.equals(modifiedBuffer.substring(idIdx+5, idIdxEnd).trim())){
                                System.out.println("Wrong response id! Will retry.");
                                return null;
                            }

                            //System.out.println("ID res:" + modifiedBuffer.substring(idIdx+5, idIdxEnd).trim());

                            modifiedBuffer = modifiedBuffer.replaceAll("\\&", "&amp;");
                            //Remove newline
                            int idx=0;
                            while((idx = modifiedBuffer.indexOf("\\n", idx))!=-1){
                                modifiedBuffer = modifiedBuffer.substring(0,idx) + " " + modifiedBuffer.substring(idx+2);
                                //System.out.println(idx);
                                idx++;
                            }

                            modifiedBuffer = modifiedBuffer.replaceAll(" +", " ");//Remove multiple spaces
                            
                            if(debug)
                                System.out.println(inputBuff);
                            return modifiedBuffer;
                        }                        
                    }
                    content_length_read = -1;
                }
            }
            br.close();		// Q. Do I need this?
        } catch (UnknownHostException e) {System.err.println("Unknown host."); e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace();}
        //catch (SocketException e){e.printStackTrace();}
        
        if (s != null) {
            try {
                s.close();
            } catch ( IOException ioEx ) {}
        }
        return null;
    }

    //Work in progress - currently unused!!!!!
    //{"id":5,"result":[{"pro_title":"I hovedet p� unger","pro_category":"Dramatik og fiktion","pro_targetgroup":"SM� B�RN (3-7)","pro_intention":"AT GIVE OPLEVELSE(R)",
    public String createList(String data, JSON parent){
        while(true){
            //System.out.println(data);
            //int curlyIndexStart = data.indexOf('{', colonIndex);
            int curlyIndexEnd = data.indexOf('}');
            int quoteIndexStart = data.indexOf('"');
            int quoteIndexEnd = data.indexOf('"', quoteIndexStart+1);
            //Find first colon that is NOT between quotes.
            int colonIndex = -1;
            do{
                colonIndex = data.indexOf(':', colonIndex+1);
                if(colonIndex==-1)
                    break;
                if(colonIndex>curlyIndexEnd){
                    colonIndex=-1;
                    break;
                }
                if((colonIndex<quoteIndexStart) || (colonIndex>quoteIndexEnd)){
                    break;
                }
            }while(true);

            //Find first comma that is NOT between quotes.
            int commaIndex = -1;
            do{
                commaIndex = data.indexOf(',', commaIndex+1);
                if(commaIndex==-1)
                    break;
                if(commaIndex>curlyIndexEnd){
                    commaIndex = -1;
                    break;
                }
                if((commaIndex<quoteIndexStart) || (commaIndex>quoteIndexEnd)){
                    break;
                }
            }while(true);


            //System.out.println("s:" + idIndexStart + " e:" + idIndexEnd + " colon:" + colonIndex);
            //System.out.println("{ s:" + curlyIndexStart + " e:" + curlyIndexEnd + " comma:" + commaIndex);

            //Search for colon or comma and ignore paranthesis
            //System.out.println(parent.name);

            if((colonIndex==-1) && (commaIndex)==-1){
                String name = data;//.substring(0, commaIndex);
                data.substring(commaIndex+1);
                System.out.println("  Last Data:" + name);
                JSON child = new JSON(name);
                parent.list.add(child);
                if(curlyIndexEnd==-1)
                    return null;
                else
                    return data.substring(curlyIndexEnd+1);

            }
            //This happens when the first thing is an ID
            else if( ((colonIndex<commaIndex) && (colonIndex != -1)) || ((colonIndex!=-1) && (commaIndex==-1)) ){
                String name = data.substring(0, colonIndex);
                System.out.println("ID:" + name);
                JSON child = new JSON(name);
                child.list = new LinkedList<JSON>();
                parent.list.add(child);
                //Create a sub element
                data = createList(data.substring(colonIndex+1), child);
                if(data==null)
                    return null;

            }
            else if((colonIndex>commaIndex)){
                if(commaIndex==-1)
                    System.out.println("ERRORLINE:" + data);
                String name = data.substring(0, commaIndex);
                System.out.println("  Data:" + name);
                JSON child = new JSON(name);
                parent.list.add(child);
                data = data.substring(commaIndex+1);
            }
        }
       
    }
   
}
