/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GUI.java
 *
 * Created on 02-11-2009, 22:34:23
 */

package webreader;

import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JList;

/**
 *
 * @author Rune
 */
public class GUI extends javax.swing.JFrame {

    private LinkedList<channelData> cl;
    private String type;
    /** Creates new form GUI */
    public GUI() {

    }

    private void fillAvailableList() {
        System.out.println("Reading channels...");
        DRtalk drt = new DRtalk();
        cl = drt.getParsedChannels(type);
        DefaultListModel lm = new DefaultListModel();
        for (channelData cd : cl) {
            lm.addElement(cd.name);
            //System.out.println(cd.name + "|" + cd.source);
        }
        jListAvailable.setModel(lm);
        sortList(jListAvailable);
        jListUsed.setModel(new DefaultListModel());
    }

    private void addItemsToList(){
        DefaultListModel lm = (DefaultListModel) jListAvailable.getModel();
        DefaultListModel lmUsed = (DefaultListModel) jListUsed.getModel();
        for (int i = 0; i < lm.size(); i++) {
            //channelData cd = cl.get(i);
            if (jListAvailable.isSelectedIndex(i)) {
                lmUsed.addElement(lm.remove(i));
                i--;//We removed an item. Must check the same index again as it contains new data
            }
        }
        sortList(jListUsed);
    }

    private void removeItemsFromList(){
        DefaultListModel lm = (DefaultListModel) jListAvailable.getModel();
        DefaultListModel lmUsed = (DefaultListModel) jListUsed.getModel();
        for (int i = 0; i < lmUsed.size(); i++) {
            //channelData cd = cl.get(i);
            if (jListUsed.isSelectedIndex(i)) {
                lm.addElement(lmUsed.remove(i));
                i--;//We removed an item. Must check the same index again as it contains new data
            }
        }
        sortList(jListAvailable);
    }
    
    private void sortList(JList ls) {
        /* Sort the channels */
        DefaultListModel lm = (DefaultListModel) ls.getModel();
        int swaps;
        do {
            swaps = 0;
            for (int i = 0; i < lm.size() - 1; i++) {
                if (lm.get(i).toString().compareTo(lm.get(i + 1).toString()) == 0) {
                    lm.remove(i);
                }
                if (lm.get(i).toString().compareTo(lm.get(i + 1).toString()) > 0) {
                    //System.out.println("Swapping:" + cl.get(i).name + " and " + cl.get(i+1).name);
                    lm.add(i + 1, lm.remove(i));
                    swaps++;
                }
            }
        } while (swaps > 0);
    }

    private boolean generateXML() {
        try {
            System.out.println("Generate XML");
            String outputFile = "channels-" + type + ".xml";
            String fileEncoding = "UTF-8";
            OutputStreamWriter outFile;
            try {
                outFile = new OutputStreamWriter(new BufferedOutputStream(new FileOutputStream(outputFile)), fileEncoding);
            } catch (IOException ex) {
                System.out.println(ex.getMessage());
                System.out.println("Error opening output file");
                return true;
            }
            outFile.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n");
            outFile.write("<!--                                                                         -->\r\n");
            outFile.write("<!-- " + type + " - Channel list used by dr.dk epg to xmltv reader.                    -->\r\n");
            outFile.write("<!-- Data between comment start and end tags are ignored.                    -->\r\n");
            outFile.write("<!-- Use this to remove channels that are not used.                          -->\r\n");
            outFile.write("<!--                                                                         -->\r\n");
            outFile.write("<channellist type=\"" + type + "\">\r\n");
            DefaultListModel lm = (DefaultListModel) jListUsed.getModel();
            for (int i = 0; i < lm.size(); i++) {
                int j = 0;
                while(!cl.get(j).name.equals(lm.get(i)) && (j<cl.size()))
                    j++;
                if(j<cl.size()){
                    System.out.println(cl.get(j).name + "|" + cl.get(j).source);
                    outFile.write("  <channel id = \"" + cl.get(j).source + "\">\r\n");
                    outFile.write("    <display-name>" + cl.get(j).name + "</display-name>\r\n");
                    outFile.write("    <icon>http://www.dr.dk/tjenester/programoversigt/Images/Logos/" + cl.get(j).icon + ".gif</icon>\r\n");
                    outFile.write("  </channel>\r\n");
                }
            }
            outFile.write("</channellist>\r\n");
            outFile.close();
        } catch (IOException ex) {
            Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
        }
        return false;
    }
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListAvailable = new javax.swing.JList();
        jButtonAdd = new javax.swing.JButton();
        jButtonRemove = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListUsed = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButtonOK = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jListAvailable.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Unable to access dr.dk" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(jListAvailable);

        jButtonAdd.setText(">");
        jButtonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddActionPerformed(evt);
            }
        });

        jButtonRemove.setText("<");
        jButtonRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonRemoveActionPerformed(evt);
            }
        });

        jScrollPane2.setViewportView(jListUsed);

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Available");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("Selected");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonAdd)
                    .addComponent(jButtonRemove))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(60, 60, 60)
                        .addComponent(jButtonAdd)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonRemove))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 272, Short.MAX_VALUE)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 272, Short.MAX_VALUE))))
                .addContainerGap())
        );

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonOK)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonCancel)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jButtonCancel, jButtonOK});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonCancel)
                    .addComponent(jButtonOK))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
        generateXML();
        System.exit(0);
    }//GEN-LAST:event_jButtonOKActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        GUI.getFrames()[0].setTitle("dr.dk EPG " + type + " channel setup");
    
    }//GEN-LAST:event_formWindowOpened

    private void jButtonAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddActionPerformed
        addItemsToList();
    }//GEN-LAST:event_jButtonAddActionPerformed

    private void jButtonRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveActionPerformed
        removeItemsFromList();
    }//GEN-LAST:event_jButtonRemoveActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        System.exit(0);
    }//GEN-LAST:event_jButtonCancelActionPerformed

    /**
    * @param args the command line arguments
    */
    public void startGUI(final String type) {
        //java.awt.EventQueue.invokeLater(new Runnable() {
        //    public void run() {
                //type = this.type;
                System.out.println("type:" + type);
                initComponents();
                this.setVisible(true);
                this.type = type;
                fillAvailableList();
       //         new GUI().setVisible(true);
       //     }
       // });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAdd;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonOK;
    private javax.swing.JButton jButtonRemove;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jListAvailable;
    private javax.swing.JList jListUsed;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables


}
